/*
 * QtUIFactory.hpp
 *
 *  Created on: Jan 14, 2010
 *      Author: crueger
 */

#ifndef QTUIFACTORY_HPP_
#define QTUIFACTORY_HPP_

// include config.h
#ifdef HAVE_CONFIG_H
#include <config.h>
#endif


#include "UIElements/UIFactory.hpp"

class QApplication;

class QtUIFactory : public UIFactory
{
  friend class UIFactory;

public:
  virtual ~QtUIFactory();

  virtual Dialog* makeDialog();
  virtual MainWindow* makeMainWindow();

  struct description : public UIFactory::factoryDescription {
    description();
    virtual ~description();

    virtual UIFactory* makeFactory();
  };
  virtual std::string getUIName(){  return "Qt4";  }

protected:
  QtUIFactory();

private:
  // faked command line arguments
  int argc;
  char **argv;
  QApplication *app;
};

#endif /* QTUIFACTORY_HPP_ */
